;ISCAT_FREERUN_LMX2541.ASM    G4JNT  Jan 2014
;ISCAT Symbol generator for driving FractN Synth directly
;Generates ISCAT symbols from raw message in RAM (may be copied from EE)

;Reg2 version programmes D register in Reg2 to avoid VCO cal glitches


    LIST P = 16F627A

        INCLUDE "P16F627A.INC"
    __config    0x3F62      ;LV Programming off , OSC HS
    __idlocs    0x8040      ;


	#define		SynthData	PORTA, 0
	#define		SynthClk	PORTA, 1
	#define		SynthLE		PORTA, 2
	#define     	KEYLINE     	PORTA, 3
    
 
	#define     	TESTLINK    	PORTB, 3
	#define     	LEDGrn      	PORTB, 4
	#define     	LEDRed      	PORTB, 5

	#define     	TXENABLE    	PORTB, 6  
	#define     	CLOCKTEST  	PORTB, 7


	#define     	TestModeFlag    Flags, 1
	#define	    	AllowData	Flags, 2
	#define     	AllowSendFlag	Flags, 3
	#define     	CurrData        Flags, 4
	#define     	HexFlag         Flags, 6

    ;For ISCAT-A and -B modes, change JTDIVIDER and NSYMBOLS 



	SERIALBITS	=	d'32'
    	CWSPEED     	=   	d'50'           ;CW Dot length, ms
	NSYMBOLS	=	d'1280'		;~ 29.7 seconds at ISCAT-A speed    change for ISCAT-B

	RAMSTART	=	0xA0		;Message stored in RAM

			;Values for 10MHz xtal

	INTDIVIDER	=	d'134'		;value X, to generate Interupt divisor N (see below)
	JTDIVIDER	=	d'116'		;  = INTSPERSECOND / Symbol rate 232 = ISCAT-A, 116 = ISCAT-B
	INTSPERSECOND	=	d'5000'		;  = Fxtal / 2000  		
	MSDELAY		=	d'124'		;  = Fxtal / 80000 - 1 

	COSTAS1	=	0
	COSTAS2	=	1
	COSTAS3	=	3
	COSTAS4	=	2

  errorlevel 1, -207  ;Suppress msgs. and warnings about labels after col 1.


;================================  EEDATA  =================
  org   0x2100
ConfigData		;24 bit words sent in sequence  for registers that remain unchanged

;  Fout 1296.54  Resolution ~43Hz    ISCAT-B
;  R =  1      
;   de  0x00, 0x00, 0x00, 0x17    ;  Reg7   	;These sent as constants in SendfromEE routine
;   de  0x00, 0x00, 0x00, 0xCD    ;  Reg13   	;  Check Reg13 VCO_DIV_OPT setting
;   de  0x00, 0x00, 0x00, 0x1C    ;  Reg12   
;   de  0x28, 0x00, 0x14, 0x09    ;  Reg9   
   de  0x01, 0x11, 0xCE, 0x58    ;  Reg8   
   de  0x00, 0x1F, 0x33, 0x26    ;  Reg6   
   de  0xA0, 0x04, 0x00, 0x05    ;  Reg5   
   de  0xFF, 0x48, 0x30, 0xA4    ;  Reg4   
   de  0x00, 0xA8, 0x73, 0x03    ;  Reg3   
   de  0x04, 0x05, 0x94, 0xB2   ;Reg2		;Duplicate this register below   (Saves finding it in this block)
   de  0x00, 0x00, 0x00, 0x31   ;Reg1
   de  0x4F, 0x1D, 0x48, 0xE0   ;Reg0		
EndConfigData

JTFreqData					;Only D register is changed
   de  0x04, 0x05, 0x94, 0xB2   ;Reg2	   Duplicate in this block to keep things simple   

IscatMsg
   de	d'22', "G8IMR IO90IV58 /     /"	;Message length, then message data in UPPER CASE, nmax 27 chars
	VARFIELD	=	d'17'	;Point in message where variables are placed

CWMsg           de   0						   
;=========================
	org     0
    nop
    movlw   b'00000000'     ;No interupts until passed thro here once
    movwf   INTCON          ;
    goto    StartUp         ;jump to main code

;------------------ Interrupt routine, get here 4 cycles after TMR overflow --
ints                           
	bcf     INTCON , T0IF   ;		5kHz interrupt
        movwf   Wreg        ;Save W
	swapf   STATUS , W      ; nb.  movwf does not affect any STATUS bits
	movwf   SaveSts         ;Stave STATUS, without affecting it

	bsf	CLOCKTEST
	movlw	INTDIVIDER
	nop			;nops needed to pad out so total clocks here 
				;  are a multiple of the prescalar value 

	movwf	TMR0		;TMR0 start recounting from here

		;Interrupt counter goes from X to 256 at Fclock / Prescale.  
		;   Let the overhead = V clocks, then int occurs every (256 - X) * P + V   clocks
		;  X =  256 - (N-V)/P    V must be padded out to be integer multiple of P

;   Below here is not time - critical any more. But must complete in remaining interrupt interval
	btfss	AllowData	;This flag decides if int routine services the message data 
	goto	KeepTime

	incf    IntCountLo
	btfsc   STATUS, Z
	incf    IntCountHi

        movlw   HIGH(JTDIVIDER)    ;5000/JTDIVIDER = symbol rate
	subwf   IntCountHi, W
	btfss   STATUS, Z
	goto    KeepTime

        movlw   LOW(JTDIVIDER)
	subwf   IntCountLo, W
	btfss   STATUS, Z
	goto    KeepTime

	   ;............             Here at Symbol Rate
	clrf    IntCountLo
	clrf    IntCountHi

	btfsc   SymbCountLo, 0    ;Flash R or G LED at half symbol rate
	bsf     LEDRed
	btfss   SymbCountLo, 0
	bcf     LEDRed

	;Count symbols continuously to make up nearly a 30 second run
	; Every 24 symbols, insert the header information (use RedLed to indicate this, perhaps)
	; otherwise, repeated step though message, look up symbol and check against length


        movlw   HIGH(NSYMBOLS)
	subwf   SymbCountHi, W
	btfss   STATUS, Z
	goto    NotLastSymbol

        movlw   LOW(NSYMBOLS)
	subwf   SymbCountLo, W
	btfss   STATUS, Z
	goto	NotLastSymbol

	bcf	AllowData	;This flag signals to main routine to send new freq data
	clrf	SymbCountHi
	clrf	SymbCountLo

	goto    KeepTime    ;  and don't do anything else
	;...............
NotLastSymbol
	incf	SymbCountLo	;post-increment so first pass uses the zero value
	btfsc	STATUS, Z
	incf	SymbCountHi
				;Insert header or message data as appropriate into 24 symb repeats
	movlw	d'6'
	subwf	BlockCount, W	;W = Count - 6, if 0/+Ve (C=1) then use message data
	btfsc	STATUS, C
	goto	NotHeader

	bsf	LEDGrn		;Change LED flashing between header and message info

;	movlw	LOW(IscatMsg)	;Get message length from EE
;	call	GetEE

	movlw	0		;Get message length
	call	GetFromRAM
	addlw	1		;Allow for the leading @	
	movwf	MsgLength

	movlw	0
	subwf	BlockCount, W
	movlw	COSTAS1
	movwf	FreqCache	
	btfsc	STATUS, Z
	goto	DoSymbol

	movlw	1
	subwf	BlockCount, W
	movlw	COSTAS2
	movwf	FreqCache	
	btfsc	STATUS, Z
	goto	DoSymbol

	movlw	2
	subwf	BlockCount, W
	movlw	COSTAS3
	movwf	FreqCache	
	btfsc	STATUS, Z
	goto	DoSymbol

	movlw	3
	subwf	BlockCount, W
	movlw	COSTAS4
	movwf	FreqCache	
	btfsc	STATUS, Z
	goto	DoSymbol


	movlw	4
	subwf	BlockCount, W
	btfss	STATUS, Z
	goto	NotM1

	movf	MsgLength, W
	movwf	FreqCache
	goto	DoSymbol
;........
NotM1			
	movf	MsgLength, W
	addlw	5
	movwf	FreqCache	
	goto	DoSymbol
;........
NotHeader		;Get next message symbol and send
	bcf	LEDGrn	

	movlw	"@"		;Preload with BOM character  
	movf	MsgCount	;Test for zero
	btfsc	STATUS, Z
	goto	BOM

	movf	MsgCount, W	;Message length value takes up the position occupided by the BOM @ 

;	addlw	LOW(IscatMsg)
;	call	GetEE		;Returns with ASCI in W

	call	GetFromRAM
BOM
	call	IscatTable	;Get symbol value to send
	movwf	FreqCache

	incf	MsgCount	;Increment after the event to allow 0 action in first pass
	movf	MsgLength, W	;Contains actual message length, allowing for the leading @
	subwf	MsgCount, W
	btfsc	STATUS, C	;W = count - length, if 0/+ve, (C=1)  restart count
	clrf	MsgCount	;Counts 0 to  [total] MsgLength -1

DoSymbol	;FreqCache has been preloaded
	bsf	AllowSendFlag   ;Pass symbol value to routine,

	incf	BlockCount	;Counts 0 - 23 repeatedly
	movlw	d'24'
	subwf	BlockCount, W	;W = Count - 24, when 0 / +Ve  (C=1) reset
	btfsc	STATUS, C
	clrf	BlockCount

KeepTime
	incf	TimCountLo
	btfsc	STATUS, Z
	incf	TimCountHi

	movlw	HIGH(INTSPERSECOND)
	subwf	TimCountHi, W
	btfss	STATUS, Z
	goto	OutInterrupt

	movlw	LOW(INTSPERSECOND)
	subwf	TimCountLo, W
	btfss	STATUS, Z
	goto	OutInterrupt

	clrf	TimCountHi
	clrf	TimCountLo

	incf	Seconds
	movlw	d'60'
	subwf	Seconds, W
	btfss	STATUS, Z
	goto	OutInterrupt
	clrf	Seconds
	incf	Minutes		;Minutes just roll 0 - 255

OutInterrupt
	bcf	CLOCKTEST                              
	swapf   SaveSts , W     ;Restore STATUS
	movwf   STATUS
	swapf   Wreg            ;Restore W
	swapf   Wreg , W        ;Can't use movf as it  affects Z bit
			
	retfie		;Vaguely 90 clocks or so in here, so OK for 125 division
;=====================================
StartUp 
    clrf    PORTA       ;Special setup to disable comparator on 'F628
    movlw   7
    movwf   CMCON
	
    bsf     STATUS,RP0      ;ram page 1
    movlw   b'00000001'     ;Internal input, Prescalar /4  pull-ups
    movwf   OPTION_REG
    movlw   b'00000000'     ;
    movwf   PORTA           ;
    movlw   b'00001011'     ; B3 TESTLINK 
    movwf   PORTB           ;B7 Clock Test output
    bcf     STATUS,RP0      ;ram page 0


    call    LongDelay	    ;Allow time for reference to establish
    call    LongDelay
    call    LongDelay	
    call    LongDelay	

    call    SendFromEE	    ;Initialise other registers
    call    LoadRAMfromEE

    clrf    PORTB
    clrf    PORTA
    clrf    TMR0
    clrf    Flags
    clrf    Seconds	  
    clrf    Minutes
    movlw   0xFF	;Preload with -1 so first increment gives zero
    movwf   SeqCountLo
    movwf   SeqCountHi

			;Launch straight in to sending, assuming unit has been reset at the minute point
    bcf     LEDGrn
    movlw   b'10000000'     ;Enable global int, not timer overflow int yet
    movwf   INTCON
    bsf     INTCON, T0IE
;...........................
MainLoop
    btfss   TESTLINK
    call    TestMode
 
    movf    Seconds, W		;At start, this happens even before the interrupt has updated the time
    sublw   d'00'
    btfsc   STATUS, Z
    goto    DoSeq 

    movf    Seconds, W
    sublw   d'30'
    btfsc   STATUS, Z
    goto    DoSeq 

    goto    MainLoop	
;..............
DoSeq
	incf	SeqCountLo
	btfsc	STATUS, Z
	incf	SeqCountHi

	movlw	VARFIELD	;point to Field where variable data sits
	addlw	RAMSTART
	movwf	FSR

	movf	SeqCountLo, W
	movwf	A0
	movf	SeqCountHi, W
	movwf	A1
	clrf	A2
	call	BinToBCD

	movf	BCDHi, W
	andlw	0x0F
	addlw	0x30
	movwf	INDF

	incf	FSR
	swapf	BCDMe, W
	andlw	0x0F
	addlw	0x30
	movwf	INDF

	incf	FSR
	movf	BCDMe, W
	andlw	0x0F
	addlw	0x30
	movwf	INDF

	incf	FSR
	swapf	BCDLo, W
	andlw	0x0F
	addlw	0x30
	movwf	INDF

	incf	FSR
	movf	BCDLo, W
	andlw	0x0F
	addlw	0x30
	movwf	INDF


    bsf     TXENABLE    ;
    bsf     KEYLINE
    bcf     LEDGrn
    movlw   0        	;Set Tone 0
    call    SendFreq
    clrf    IntCountLo
    clrf    IntCountHi
    clrf    SymbCountLo    ;Re-Initialise registers
    clrf    SymbCountHi
    clrf    BlockCount
    clrf    MsgCount

    bsf     AllowData	 ;Starts JT sequence

JTLoop
	btfss	AllowSendFlag
	goto    NoSend

	movf    FreqCache, W
	call    SendFreq		;Has to be done outside interrupt routine
	bcf	AllowSendFlag	; as an interrupt overrun would occur
NoSend
	btfsc   AllowData	 ;Sit in here waiting for completion   
	goto    JTLoop

	movlw   0        	;Set Tone 0
	call    SendFreq

	bcf     KEYLINE
	bcf     TXENABLE
	bsf     LEDGrn
	bcf	LEDRed

	goto    MainLoop

;.............................
DoCW
    call    LongDelay
    movlw   LOW(CWMsg)
    movwf   CWMsgCnt
    call    SendCWMsg
    goto    MainLoop
;===========================================
TestMode                    ;TESTLINK Input grounded
    bsf     LEDRed
    bcf     LEDGrn
    movlw   0        	;Set Tone 0
    call    SendFreq
TestModeLoop
    btfss   TESTLINK
    goto    TestModeLoop

    bcf     LEDRed
    bcf     TXENABLE
    bcf     KEYLINE
    return
;--------------------------------
GetEE         ;different from ;F84   EE registers all in bank 1 now 
	bsf     STATUS,RP0      ;ram page 1
	movwf   EEADR
	bsf     EECON1 , RD
	movf    EEDATA , W
	bcf     STATUS , RP0    ;ram page 0
	return
;-----------------------
LongDelay           ;Approx 1 second delay
	movlw   d'250'
	movwf   DelCount2
LongDelLoop
	call    Delay1ms
	call    Delay1ms
	call    Delay1ms
	call    Delay1ms
	decfsz  DelCount2
	goto    LongDelLoop
	return
;-------------------------
Delay1ms        ;20N+5
	movlw   MSDELAY
	movwf   DelCount
Del1msLoop
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	nop
	decfsz  DelCount
	goto    Del1msLoop
	return
;-------------------------
LoadRAMfromEE
	movlw	LOW(IscatMsg)
	call	GetEE		;Load length of message
	movwf	MsgLength
	incf	MsgLength	;Allow for initial length byte

	clrf	MsgCount
LoadLoop			;Load EE data into RAM, including the initial length byte
	movf	MsgCount, W	
	addlw	RAMSTART
	movwf	FSR

	movf	MsgCount, W
	addlw	LOW(IscatMsg)
	call	GetEE
	movwf	INDF	

	incf	MsgCount
	movf	MsgLength, W
	subwf	MsgCount, W
	btfss	STATUS, Z
	goto	LoadLoop
		
	return

;-------------------------------
GetFromRAM	;Enter with relative offset in W
	addlw	RAMSTART
	movwf	FSR
	movf	INDF, W
	return
;-------------------------------
PushStack
	movf    StackE , W
	movwf   StackF
	movf    StackD , W  
	movwf   StackE
	movf    StackC , W
	movwf   StackD
	movf    StackB , W
	movwf   StackC
	movf    StackA , W
	movwf   StackB
	movf    Stack9 , W
	movwf   StackA
	movf    Stack8 , W
	movwf   Stack9
	movf    Stack7 , W
	movwf   Stack8
	movf    Stack6 , W
	movwf   Stack7 
	movf    Stack5 , W
	movwf   Stack6
	movf    Stack4 , W
	movwf   Stack5
	movf    Stack3 , W
	movwf   Stack4
	movf    Stack2 , W
	movwf   Stack3
	movf    Stack1 , W
	movwf   Stack2
	movf    Stack0 , W
	movwf   Stack1

	return
;-------------------------------
SendCWMsg           ;Enter with EE address programmed into CWMsgCnt
	movf    CWMsgCnt, W
    call    GetEE       ;Test for terminator at start = no CW message
	addlw   0
	btfsc   STATUS, Z
	return
    bcf     KEYLINE
	call    CWDelay
	call    CWDelay
	call    CWDelay
	call    CWDelay

CWLoop
	movf    CWMsgCnt, W
	call    GetEE
	addlw   0
	btfsc   STATUS, Z
	goto    DoneCWMsg

	call    SendCWChar
	incf    CWMsgCnt
	goto    CWLoop
DoneCWMsg
	call    CWDelay
	call    CWDelay
	call    CWDelay
	call    CWDelay
	return
;--------------------------
SendCWChar      ;Sends a single CW character
	addlw   0xE0     ;Subtract 32 (add 256 - 32) to point to table
	call    CWTable
	movwf   CWChar      ;Doesn't affect STATUS so...
	movf    CWChar      ;  check for invalid returned code here
	btfsc   STATUS , Z      
	goto    NoChar

	movlw   0x07    
	andwf   CWChar , W      ;Extract element count into W
	movwf   CWCharCnt     
    movlw   6       
	subwf   CWCharCnt , W     ;W = Elcount - 6.  If +ve/0 then C=1, > 5 els
	btfss   STATUS , C
	goto    Send5
	
	rrf     CWCharCnt   ;Puts LSB into C as 110 = .  111 = -
	call    SendEle     ;First  . or -  for 6 element characters
	movlw   5
	movwf   CWCharCnt     ;Force count to 5 for rest of the elements
Send5       
	rlf     CWChar      ;Element to be sent into C.
	call    SendEle     ;   count already in Counter
	decfsz  CWCharCnt   
	goto    Send5
NoChar          ;Inter word gap, and invalid codes.
	bcf     LEDRed
	call    CWDelay
	call    CWDelay
	return
;-------------------
SendEle         ;Data in STATUS , C;  0 = dit  1 = dah
	rrf     Stack0      ;Save C bit temporarily on stack
    bsf     KEYLINE
	bsf     LEDRed
	rlf     Stack0      ;Recovery C bit again, to get dot/dash 
	btfss   STATUS , C      ;test for dot or dash
	goto    SendDot
	call    CWDelay
	call    CWDelay
SendDot
	call    CWDelay
    bcf     KEYLINE
	bcf     LEDRed
    call    CWDelay     ;Inter element gap
	return
;-------------------
CWDelay       
	movlw   CWSPEED
	movwf   DelCount2
CWDelLoop
	call    Delay1ms      
	decfsz  DelCount2
	goto    CWDelLoop
	return
;-------------------------
;-------------------------
SendFreq		;Takes JTxx code 0 - nn, constructs register R2 and sends to synth chip
	movwf	Temp	;  This verson modified for Reg2 programming

	subwf	LastFreq, W	;Don't reprog the synth if same frequency is requested, 
	btfsc	STATUS, Z	;Avoids glitches due to chip responding to reprogging
	return

	movf	Temp, W
	movwf	LastFreq	;Update the current value

	movlw	LOW(JTFreqData + 3)	;Reg2 data is the first item in the block, so can be recalled without an offset
	call	GetEE
	movwf	Tx0

	movlw	LOW(JTFreqData + 2)
	call	GetEE
	movwf	Tx1

	movlw	LOW(JTFreqData + 1)		
	call	GetEE
	movwf	Tx2

	movlw	LOW(JTFreqData + 0)
	call	GetEE
	movwf	Tx3

	swapf	Temp, W		;Recover tone number, 0 to 65, and multiply by 16, placing result in A0/1
	andlw	0xF0		;  *16 is needed to align with Reg2 values
	movwf	A0	
	swapf	Temp, W		;
	andlw	0x0F
	movwf	A1	
	clrf	A2
	clrf	A3

	movf	A0, W
	subwf	Tx0

	movf	A1, W		
	btfss	STATUS, C
	incfsz	A1, W
	subwf	Tx1

	movf	A2, W		;A2 and A3 will be zero, but we might as well just use the full subtraction routine
	btfss	STATUS, C
	incfsz	A2, W
	subwf	Tx2

	movf	A3, W
	btfss	STATUS, C
	incfsz	A3, W
	subwf	Tx3

	movlw	0xF0		;Rest of the Reg2 data formatting
	andwf	Tx0	
	movlw	2		;Sets address
	iorwf	Tx0

	movlw	0x02		;Mask demon data and and set Bit 26
	andwf	Tx3
	bsf	Tx3, 2
SendSynth       ; ~~~~~~ Jump straight in here when other registers are sent from EE ~~~~~~~~

	bcf	SynthLE	
	movlw	SERIALBITS
	movwf	BitCount
SendChipLoop
	bcf	SynthClk
	rlf	Tx0
	rlf	Tx1
	rlf	Tx2
	rlf	Tx3		;Working bit in C
	btfsc	STATUS, C	
	bsf	SynthData		
	btfss	STATUS, C
	bcf	SynthData

	goto	$+1
	goto	$+1
	bsf	SynthClk	;Clocked in on rising edge

	decfsz	BitCount
	goto	SendChipLoop

	bcf	SynthClk	;Place into rest state
	bcf	SynthData
	nop
	bsf	SynthLE		;Needs to get back low in 1us
	bcf	SynthLE

	return


;-------------------------;------------------------------
SendFromEE		;Send all registers that are not part of the frequency setting
			;first 4 registers defined by constants to save EE

;   de  0x00, 0x00, 0x00, 0x17    ;  Reg7   
;   de  0x00, 0x00, 0x00, 0xCD    ;  Reg13   
;   de  0x00, 0x00, 0x00, 0x1C    ;  Reg12   
;   de  0x28, 0x00, 0x14, 0x09    ;  Reg9   

	clrf	Tx3
	clrf	Tx2
	clrf	Tx1
	movlw	0x17
	movwf	Tx0
	call	Delay1ms
	call	SendSynth

	clrf	Tx3
	movlw	0x00		;Contains VCO_DIV_OPT, could be  0x04 See data sheet
	movwf	Tx2
	clrf	Tx1
	movlw	0xCD
	movwf	Tx0
	call	Delay1ms
	call	SendSynth

	clrf	Tx3
	clrf	Tx2
	clrf	Tx1
	movlw	0x17
	movwf	Tx0
	call	Delay1ms
	call	SendSynth

	movlw	0x28
	movwf	Tx3
	movlw	0x00
	movwf	Tx2
	movlw	0x14
	movwf	Tx1
	movlw	0x09
	movwf	Tx0
	call	Delay1ms
	call	SendSynth
			
			;Do the rest from EE
	movlw	LOW(ConfigData)
	movwf	AutoEEADR	
FromEELoop
	movf	AutoEEADR, W
	call	GetEE
	movwf	Tx3

	incf	AutoEEADR
	movf	AutoEEADR, W
	call	GetEE
	movwf	Tx2

	incf	AutoEEADR
	movf	AutoEEADR, W
	call	GetEE
	movwf	Tx1

	incf	AutoEEADR
	movf	AutoEEADR, W
	call	GetEE
	movwf	Tx0

	call	Delay1ms
	call	SendSynth

	incf	AutoEEADR
	movlw	LOW(EndConfigData)
	subwf	AutoEEADR, W		;W = Address - EndOfDataLabel, when 0/+Ve, C=1, exit sending
	btfss	STATUS, C	
	goto	FromEELoop

	return		

	return
;----------------------------------------------------------------------------------------
;---------------------------
SyncToStack
	movlw   0x98
	movwf   StackF
	movlw   0xFD
	movwf   StackE
	movlw   0x45
	movwf   StackD
	movlw   0x91
	movwf   StackC
	movlw   0xCF
	movwf   StackB
	movlw   0x6F
	movwf   StackA
	movlw   0x1A
	movwf   Stack9
	movlw   0xB3
	movwf   Stack8
	movlw   0x54
	movwf   Stack7
	movlw   0x81
	movwf   Stack6
	movlw   0x80
	movwf   Stack5
	movlw   0xD2
	movwf   Stack4
	movlw   0xD5
	movwf   Stack3
	movlw   0x32
	movwf   Stack2
	movlw   0x43
	movwf   Stack1
	movlw   0xFC
	movwf   Stack0

	return
;---------------------------------------
;--------------------------
BinToBCD            ;Takes in A2/A1/A0, calculates packed BCD equivalent
    clrf    BCDVi   ;Result in BCDVi/Hi/Me/Lo
    clrf    BCDHi   ;Also uses BcdCounter, BcdTemp  Destroys A
    clrf    BCDMe   ;  may be able to reuse Acc registers in some cases
    clrf    BCDLo   ;Approx 1235 clocks
    movlw   d'24'
    movwf   BcdCounter
BcdLoop
    rlf     A0
    rlf     A1
    rlf     A2
    rlf     BCDLo
    rlf     BCDMe
    rlf     BCDHi
    rlf     BCDVi
    decfsz  BcdCounter     ;Need a final shift only, so loop count here
    goto    BCDgo
    goto    BCDone
    ;..........
BCDgo
    movf    BCDVi , W
    addlw   3
    movwf   BcdTemp
    btfsc   BcdTemp , 3
    movwf   BCDVi       ;If BCDVi >= 5, add 3 and store back

    movf    BCDVi , W
    addlw   0x30
    movwf   BcdTemp
    btfsc   BcdTemp , 7
    movwf   BCDVi       ;Adjust BCDVi if > 80

    movf    BCDHi , W
    addlw   3
    movwf   BcdTemp
    btfsc   BcdTemp , 3
    movwf   BCDHi      

    movf    BCDHi , W
    addlw   0x30
    movwf   BcdTemp
    btfsc   BcdTemp , 7
    movwf   BCDHi       

    movf    BCDMe , W   ;Repeating for middle then low digits
    addlw   3
    movwf   BcdTemp
    btfsc   BcdTemp , 3
    movwf   BCDMe      

    movf    BCDMe , W
    addlw   0x30
    movwf   BcdTemp
    btfsc   BcdTemp , 7
    movwf   BCDMe     

    movf    BCDLo , W   ;
    addlw   3
    movwf   BcdTemp
    btfsc   BcdTemp , 3
    movwf   BCDLo    

    movf    BCDLo , W
    addlw   0x30
    movwf   BcdTemp
    btfsc   BcdTemp , 7
    movwf   BCDLo   

    goto    BcdLoop
    ;...........
BCDone
    return
;====================
;============================================
org 0x300

IscatTable                 ;Enter with ASCII in W, exit with tone pattern
        movwf   Temp
        movlw   HIGH($)
        movwf   PCLATH
        movf    Temp, W
        addlw   0xE0            ;Add 244 == subtract 32
        addwf   PCL

        dt	d'36'   				;[SP]  32
        dt	d'36',d'36',d'36',d'36',d'36',d'36' 	;! " # $ % &
        dt	d'36',d'36',d'36',d'36',d'36',d'36' 	;' ( ) * + ,
        dt 	d'41'   				;   -  Ascii 45
        dt	d'38'   				;   .  
        dt	d'37'   				;   /  
        dt	0,1,2,3,4,5,6,7,8,9			;0 - 9
        dt	d'36',d'36',d'36',d'36',d'36' 		;   , ; < = >
        dt	d'39'   				;  ?   Ascii 63
        dt	d'40'       				;  @
        dt	d'10',d'11',d'12',d'13',d'14',d'15',d'16',d'17',d'18',d'19'	;A - J     
        dt	d'20',d'21',d'22',d'23',d'24',d'25',d'26',d'27',d'28',d'29'	;K - T     
        dt	d'30',d'31',d'32',d'33',d'34',d'35'				;U - Z
;--------------------------------------
CWTable       ;CW Characters in compressed form. 
	movwf   Temp
	movlw   HIGH($)
	movwf   PCLATH    
	movf    Temp , W
	addwf   PCL
	
	retlw   b'00000000'  ; [sp] 00
	retlw   b'00000000'  ;  !   00
	retlw   b'10010110'  ;  "   96
	retlw   b'00010101'  ;  #   15
	retlw   b'00000000'  ;  $   00
	retlw   b'00000000'  ;  %   00
	retlw   b'00000000'  ;  &   00
	retlw   b'11110110'  ;  '   F6
	retlw   b'10110101'  ;  (   B5
	retlw   b'01101111'  ;  )   6F
	retlw   b'01000101'  ;  *   45
	retlw   b'00000000'  ;  +   00
	retlw   b'10011111'  ;  ,   9F     Coding for CW characters of up to
	retlw   b'00001111'  ;  -   0F      6 elements.  Stored as :
	retlw   b'10101110'  ;  .   AE     Bits 7 to 3 make first five CW elements
	retlw   b'10010101'  ;  /   95     Reading  Left to Right 
	retlw   b'11111101'  ;  0   FD     Coded as 0 = dit   1 = dah
	retlw   b'01111101'  ;  1   7D     Bts 2-0 are number of elements except for 
	retlw   b'00111101'  ;  2   3D     110 > 1st element is a dit  
	retlw   b'00011101'  ;  3   1D     111 > 1st element is a dah       
	retlw   b'00001101'  ;  4   0D
	retlw   b'00000101'  ;  5   05
	retlw   b'10000101'  ;  6   85
	retlw   b'11000101'  ;  7   C5
	retlw   b'11100101'  ;  8   E5
	retlw   b'11110101'  ;  9   F5
	retlw   b'00000000'  ;  :   00
	retlw   b'00000000'  ;  ;   00
	retlw   b'00000000'  ;  <   00
	retlw   b'10001101'  ;  =   8D
	retlw   b'00000000'  ;  >   00
	retlw   b'01100110'  ;  ?   66
	retlw   b'11010110'  ;  @   D6
	retlw   b'01000010'  ;  A   42
	retlw   b'10000100'  ;  B   84
	retlw   b'10100100'  ;  C   A4
	retlw   b'10000011'  ;  D   83
	retlw   b'00000001'  ;  E   01
	retlw   b'00100100'  ;  F   24
	retlw   b'11000011'  ;  G   C3
	retlw   b'00000100'  ;  H   04
	retlw   b'00000010'  ;  I   02
	retlw   b'01110100'  ;  J   74
	retlw   b'10100011'  ;  K   A3
	retlw   b'01000100'  ;  L   44
	retlw   b'11000010'  ;  M   C2
	retlw   b'10000010'  ;  N   82
	retlw   b'11100011'  ;  O   E3
	retlw   b'01100100'  ;  P   64
	retlw   b'11010100'  ;  Q   D4
	retlw   b'01000011'  ;  R   43
	retlw   b'00000011'  ;  S   03
	retlw   b'10000001'  ;  T   81
	retlw   b'00100011'  ;  U   23
	retlw   b'00010100'  ;  V   14
	retlw   b'01100011'  ;  W   63
	retlw   b'10010100'  ;  X   94
	retlw   b'10110100'  ;  Y   B4
	retlw   b'11000100'  ;  Z   C4



;--------------------------------
    cblock 0x20
        Temp
	AutoEEADR
        DelCount, DelCount2
        IntCountLo,  IntCountHi
	TimCountLo, TimCountHi
        Counter
        SymbCountLo, SymbCountHi       ;Counts 0 to NSYMBOLS
	SeqCountLo, SeqCountHi
	BlockCount
	MsgCount
        Amplitude
	MsgLength	;Used in generating hesader
        Flags
        Wreg
        SaveSts
        Seconds, Minutes
        ICount
	BitCount
	Tx0, Tx1, Tx2, Tx3
	F0, F1
	N0, N1
        CommaCount
        CWChar, CWMsgCnt, CWCharCnt
        RxChar
	FreqCache
	LastFreq
        TonePtr
        SerCounter      
        AddrHold
	A0, A1, A2, A3
	BCDLo, BCDMe, BCDHi, BCDVi, BcdTemp, BcdCounter
        Stack0, Stack1, Stack2, Stack3, Stack4, Stack5, Stack6, Stack7 
	Stack8, Stack9, StackA, StackB, StackC, StackD, StackE, StackF
    endc   
;==========================================
		end
